Calib = zeros(2, 15);

for k = 0:14,
  q = fscanfMat('lectures_potars/q'+string(k)+'.data');
  pot = fscanfMat('lectures_potars/potars'+string(k)+'.data');
  A = [sum(pot.^2), sum(pot); sum(pot), size(pot, 1)]\[sum(pot.*q); sum(q)];
  
  xset('window', k);
  xname('Erreur en degres sur l''etalonnage du potentiometre no. '+string(k));
  xbasc();
  plot(pot,q*180/%pi);
  plot2d(q*180/%pi, (q-A(1)*pot-A(2))*180/%pi);
  
  Calib(:, k+1) = A;
end;

template_BipPotars_h = "..
/************************************************************\n..
Fichier d''etalonnage des 15 potentiometres du robot BIP,\n..
genere automatiquement par CalibPotars.sce.\n\n..
Ces constantes relient la position articulaire q (en radians)\n..
a la lecture en sortie des potentiometres potars (en Volt)\n..
de la facon suivante:\n\n..
         q = Potxxxx_x * potars + Offxxxx_x\n\n..
************************************************************/\n..
#define PotCheD_F %f\n..
#define OffCheD_F %f\n\n..
#define PotCheD_S %f\n..
#define OffCheD_S %f\n\n..
#define PotGenD_S %f\n..
#define OffGenD_S %f\n\n..
#define PotHanD_S %f\n..
#define OffHanD_S %f\n\n..
#define PotCheG_F %f\n..
#define OffCheG_F %f\n\n..
#define PotCheG_S %f\n..
#define OffCheG_S %f\n\n..
#define PotGenG_S %f\n..
#define OffGenG_S %f\n\n..
#define PotHanG_S %f\n..
#define OffHanG_S %f\n\n..
#define PotHanD_F %f\n..
#define OffHanD_F %f\n\n..
#define PotHanD_V %f\n..
#define OffHanD_V %f\n\n..
#define PotHanG_F %f\n..
#define OffHanG_F %f\n\n..
#define PotHanG_V %f\n..
#define OffHanG_V %f\n\n..
#define PotLomb_V %f\n..
#define OffLomb_V %f\n\n..
#define PotLomb_F %f\n..
#define OffLomb_F %f\n\n..
#define PotLomb_S %f\n..
#define OffLomb_S %f\n\n";

unix("rm -f BipPotars.h");
fprintf("BipPotars.h", template_BipPotars_h, Calib(1), Calib(2),..
Calib(3), Calib(4), Calib(5), Calib(6), Calib(7), Calib(8),..
Calib(9), Calib(10), Calib(11), Calib(12), Calib(13), Calib(14),..
Calib(15), Calib(16), Calib(17), Calib(18), Calib(19), Calib(20),..
Calib(21), Calib(22), Calib(23), Calib(24), Calib(25), Calib(26),..
Calib(27), Calib(28), Calib(29), Calib(30));
