/**********************************************************************
**                                                                   **
** $Id: Rsock.h,v 1.1.1.1 1998/09/22 07:38:10 pissard Exp $          **
**                                                                   **
** Modifications:						     **
**  8 February 1993     (jls)   creation			     **
**								     **
** Description:							     **
** Message exchanges under TCP/IP				     **
**								     **
**								     **
**********************************************************************/
#ifndef socketLib_h
#define socketLib_h

#include <Rmi.h>

/* La structure de memoire de l'ensemble des sockets */
typedef struct sockServer {
   int s_generic;
   int s_client;
   int port_nb;
   char hostnumber[100];
} SOCK_SERVER;

#ifdef __cplusplus
extern "C" {
#endif
#ifdef __STDC__
extern int sockClientOpen(SOCK_SERVER *pSock,char *host,int port_nb);
extern int sockServerOpen(SOCK_SERVER *socket_server,int port_nb);
extern int sockClose (SOCK_SERVER *pSock);
extern int sockSendString(SOCK_SERVER *pSock,char *msg);
extern int sockSend(SOCK_SERVER *pSock,char *msg,unsigned int size);
extern int sockRec(SOCK_SERVER *pSock,char *msg,unsigned int sizemax);
extern int sockSendImage(SOCK_SERVER *pSock,MI_IMAGE image);
extern int sockRecImage(SOCK_SERVER *pSock,MI_IMAGE *image);
extern int sockIsAlive(SOCK_SERVER *pSock);
extern unsigned int sockMsgLength(SOCK_SERVER *pSock);

#ifdef VXWORKS
extern SOCK_SERVER *sockGetStructure(int clientId, SEM_ID *sem_mutex);
extern int sockServerOpenMultiClients(int port_nb, FUNCPTR fonction);
#endif

#else
extern int sockClientOpen();
extern int sockClose ();
extern int sockSendImage();
extern int sockRecImage();
extern int sockSendString();
extern int sockSend();
extern int sockRec();
extern unsigned int sockMsgLength();
extern int sockIsAlive();
extern int sockKernelBufferSize();
extern int sockServerOpen();
#endif

#ifdef __cplusplus
}
#endif

#endif   /* ! socketLib_h */
