#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>
#include <sysLib.h>

#include "comBip.h"

#define CHEMIN "/home/mouflon/jarde/BIP/utils_vxworks/Socket/test_sock_bip_client"
#define NBLOOP 1000
#define DIM_CONTACTS 24

int count=0;

/***********************/
/* creation d'un timer */
/***********************/
int clk()
{
count++;
return(count);
}

/*******************************************/
/* fonction de sauvegarde des temps de com */
/*******************************************/
int combipSaveTime(char *filename, int tableau[NBLOOP])
{
  int i;
  FILE *fp;

  /* open the file */
  fp = fopen(filename,"w");
  if (!fp) return ERROR;

  /* enregistrement des valeurs */
  for (i=0; i<NBLOOP;i++)
    {
      fprintf(fp, "%d\n", tableau[i]);
    }

  /* fermeture du fichier */
  fclose(fp);

  return(OK);
}

/*********************/
/* Init combipStruct */
/*********************/
int combipAffectTest(COMBIP_DESC *combipStruc)
{
  int i;

  for(i = 0; i < combipStruc->dimrow ; i++) {
    combipStruc->q[i] = 0;
    combipStruc->qdot[i] = 0;
    combipStruc->commande[i] = 0;
  }
  
  for(i = 0; i < DIM_CONTACTS ; i++) {
    combipStruc->lambda[i] = 0;
  }  

  return OK;
}

/************************************************/
/* Client program send a request for the server */
/* and wait for the message of the server       */
/************************************************/
int sockclientest() 
{
  COMBIP_DESC bipVect;
  char target[20];
  char vect2Str[SIZE_STR];
  int i, k, clk_send, clk_receive;
  int tab[NBLOOP];
  char name[64];
    
  /* mise en place de l'interruption timer */
  /* interruption toutes les 1 ms (1000/frequence) */
  sysAuxClkRateSet(1000);
  sysAuxClkConnect(clk, 0);
  
  /* Create the Bip Struct -> vector dimension = 21 */
  combipStructCreate(&bipVect,21);

  /* Client opens connection */
  printf("entree le nom du serveur cible:");
  scanf("%s", target);
  printf("Le nom du serveur cible est:%s\n",target);
  
  combipOpenClient(target);
 
  /* Create q, qdot and lambda vector message to send */
  combipAffectTest(&bipVect);
  
  /* launch clock */
  sysAuxClkEnable();
  printf("clk_initiale = %d\n", count);
  
  for (k = 0 ; k < NBLOOP ; k++) 
  {
  	/* Send q, qdot and lambda as input */
	clk_send = count;
  	combipSockSendq(&bipVect);
    	combipSockSendqdot(&bipVect);
	combipSockSendLambda(&bipVect);
	
  	/* Wait for the message from the server to get the G value */
  	combipSockRecCom(&bipVect);
	
	/* get time and eval it between the sent and the reception*/
	clk_receive = count;
  	printf("timeval = %d ms\n", clk_receive - clk_send);
	
	/* fill tab with the comunication time */
  	tab[k] = clk_receive - clk_send;
	
	/* Display commande */
	for(i = 0 ;  i < bipVect.dimrow ; i ++) 
    	{
		printf("com[%d] = %lf \n", i, bipVect.commande[i]);
    	}
	
	/* reinitialize combipStruct */
	combipAffectTest(&bipVect);
  }
  
  /* stop clock */
  sysAuxClkDisable();
  
  /* save the time result in a file */
  sprintf(name, "%s/time.data", CHEMIN); 
  combipSaveTime(name, tab);
  
  /* fermeture de la socket */
  printf("closing socket\n");
  combipClose();
  return(0);
}
