/*****************************  Bipede   ******************************
**								     **
** File           : $HOME/BIP/utils_vxworks/Socket/comBip.c	     **
** Author         : RPG, Soraya Arias and Sbastien Jard	     **
** Version        : 1.1 					     **
** Creation       : 1 Juillet 2002				     **
**								     **
******************************* Description ***************************
**								     **
**  Gestion par string de la communication pour le calcul de 	     **
**  la loi de commande du robot BIP			     	     **
**								     **
****************************** Modifications **************************
**								     **
** PBPBPB : affectation de la structure combip desc !!		     **
**								     **
***********************************************************************
** (c) Copyright 2000, INRIA, all rights reserved		     **
**********************************************************************/
#ifndef __combip_h
#define __combip_h

#include "Rsock.h"

#define PORT 5001
#define MAX_SIZE_MESSAGE 1024
#define SIZE_STR 1024

typedef struct _COMBIP_DESC
{
  int dimrow; 
  double *q;
  double *qdot;
  double *lambda;
  double *commande;
  int status;
} COMBIP_DESC;
 

SOCK_SERVER *combipSocket();

/* Create combip structure */
int combipStructCreate(COMBIP_DESC *combipStruct, int dim);
/* Send q Vector throug socket */
int combipSockSendq(COMBIP_DESC *bipVect);
/* Send qdot Vector throug socket */
int combipSockSendqdot(COMBIP_DESC *bipVect);
/* Send Lambda Vector throug socket */
int combipSockSendLambda(COMBIP_DESC *bipVect);
/* Send Commande Vector throug socket */
int combipSockSendCom(COMBIP_DESC *bipVect);

/* Receive q Vector throug socket */
int combipSockRecq(COMBIP_DESC *bipVect);
/* Receive qdot Vector throug socket */
int combipSockRecqdot(COMBIP_DESC *bipVect);
/* Receive Lambda Vector throug socket */
int combipSockRecLambda(COMBIP_DESC *bipVect);
/* Receive Commande Vector throug socket */
int combipSockRecCom(COMBIP_DESC *bipVect);

/*********************************************************/
/* Ouvre 1 socket Serveur, lance 1 tache qui boucle avec */
/* 1 delay et regulierement fait 1 demande de calcul     */
/*********************************************************/
int combipOpen();

/******************************************************/
/* Ouvre 1 socket Client, attend 1 requete de calcul, */
/* fait le calcul, et renvoie la valeur  du calcul    */
/******************************************************/
int combipOpenClient(char *target);

int combipClose();

#endif
