////////////////////////////////////////////////////
// definitions de la fonction de cout a minimiser //
////////////////////////////////////////////////////
function [diff] = cout_obs(q2_test, q1, contacts_actifs, positions_contacts)

q_obs = [ q1; q2_test ];
C = positions_contacts([contacts_actifs; contacts_actifs; contacts_actifs;], :);

c_obs = contact(q_obs);
C_obs = c_obs([contacts_actifs; contacts_actifs; contacts_actifs;], :);

diff = ( C_obs - C );
diff = 0.5 * diff'*diff;

/////////////////////////////////////
// gradient de la fonction de cout //
/////////////////////////////////////
function [grad_diff] = gradient_obs(q2_test, q1, contacts_actifs, positions_contacts)

q_obs = [ q1; q2_test ];
C = positions_contacts([contacts_actifs; contacts_actifs; contacts_actifs;], :);

c_obs = contact(q_obs);
C_obs = c_obs([contacts_actifs; contacts_actifs; contacts_actifs;], :);

j_obs = jacobien_contact(q_obs);
J_obs = j_obs([contacts_actifs; contacts_actifs; contacts_actifs;], :);

grad_diff = J_obs' * ( C_obs - C );
grad_diff = grad_diff(16:21);

///////////////////////////////////////
// definition d'un observateur de q2 //
///////////////////////////////////////
function [q2_obs] = observateur (q1, q2_obs_prec, contacts_actifs, positions_contacts)

// definition d'une fonction de cout qui retourne la fonction a 
//minimiser et son gradient. 

deff('[d, gradient, ind] = costf(q2_test, ind)', 
     'd = cout_obs(q2_test, q1, contacts_actifs, positions_contacts), 
     gradient = gradient_obs(q2_test, q1, contacts_actifs, 
     positions_contacts)');

[d,q2_test,gradient_opt]=optim(costf,q2_obs_prec,'gc');

q2_obs = q2_test;
q2_obs_prec = q2_obs;
q2_obs_prec = resume(q2_obs_prec);
