///////////////////////////////////////////////////
// f(q2) = contact([q1,q2]) - positions_contacts //
///////////////////////////////////////////////////
function [diff] = cout(q2, q1, contacts_actifs, positions_contacts)

q_obs = [ q1; q2 ];
C = positions_contacts([contacts_actifs; contacts_actifs; contacts_actifs;], :);

c_obs = contact(q_obs);
C_obs = c_obs([contacts_actifs; contacts_actifs; contacts_actifs;], :);

diff = ( C_obs - C );

///////////////////////////
// jacobien de q2 : J(q2)//
///////////////////////////
function [J_q2] = jacobien_q2(q2, q1, contacts_actifs)

q_obs = [ q1; q2 ];

j_obs = jacobien_contact(q_obs);
J_obs = j_obs([contacts_actifs; contacts_actifs; contacts_actifs;], :);

J_q2 = J_obs(:, 16:21);

///////////////////////////////////////////////////////////////////
// construction d'un observateur de q2 par la methode precedente //
///////////////////////////////////////////////////////////////////
function [q2_obs] = observateur (q1, q2_obs_prec, contacts_actifs, positions_contacts)
				 
f_q2 = cout(q2_obs_prec, q1, contacts_actifs, positions_contacts);
J_q2 = jacobien_q2(q2_obs_prec, q1, contacts_actifs);

q2_obs = q2_obs_prec - inv(J_q2'*J_q2)*J_q2'*f_q2;

q2_obs_prec = q2_obs;
q2_obs_prec = resume(q2_obs_prec);
